import { Ref } from 'vue';
import { InputExpose } from '@/components/hive-input/hive-input.vue';
import { Value, Options, CurrentOptionsRef } from '@/common/types/select';
export type ListMethodsConfig = {
    options: Options | undefined;
    modelValue: Value | Value[];
    withUndefined: boolean;
    withNull: boolean;
    nullTitle: string;
    fieldTitle: string;
    fieldValue: string;
    autocomplete?: boolean;
};
export declare const useListMethods: ({ options, modelValue, withUndefined, withNull, nullTitle, fieldTitle, fieldValue, autocomplete, }: ListMethodsConfig) => {
    isExpanded: Ref<boolean>;
    activeValue: Ref<Value>;
    updateActiveValue: (value: Value) => void;
    currentValue: Ref<Value | Value[]>;
    current: CurrentOptionsRef;
    updateCurrentValue: (value: Value | undefined) => void;
    searchQuery: Ref<string>;
    searchRef: Ref<InputExpose | null>;
    searchInput: import("vue").ComputedRef<HTMLInputElement | null | undefined>;
    expand: () => void;
    collapse: () => void;
    toggle: () => void;
    filteredOptions: Ref<Map<any, any>>;
    currentOptions: Ref<Map<any, any>>;
    setPrevActiveValue: () => void;
    setNextActiveValue: () => void;
};
