import { WritableComputedRef } from 'vue';
import { CommonProps } from '@/common/mixin/props';
import type { Value } from '@/common/types/select';
import type { GridColumns } from './types';
interface Props extends CommonProps {
    dataItems: any[] | undefined;
    columns: GridColumns[];
    itemsOnPage?: number;
    showAddButtons?: boolean;
    hasFilter?: boolean;
    colorAlternation?: boolean;
    hideHeader?: boolean;
    query?: string;
    filterFields?: string[];
    filterCaseSensitive?: boolean;
    page?: number;
}
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    showAddButtons: boolean;
    itemsOnPage: number;
    hasFilter: boolean;
    colorAlternation: boolean;
    hideHeader: boolean;
    query: string;
    page: number;
}>, {
    items: WritableComputedRef<object[]>;
    grid: import("vue").ComponentInternalInstance | null;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    mount: () => void;
    unmount: () => void;
    "update:modelValue": (value: Value) => void;
    "model-value-updated": (value: Value) => void;
    focusin: () => void;
    focusout: () => void;
    keydown: (event: KeyboardEvent) => void;
    search: (query: string) => void;
    queryUpdate: (value: string) => void;
    rowClick: (row: Record<string, unknown>, rowRef: ({
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            showAddButtons: boolean;
            colorAlternation: boolean;
        }> & Omit<{
            readonly item: Record<string, unknown>;
            readonly columns: GridColumns[];
            readonly showAddButtons: boolean;
            readonly index: number;
            readonly itemsOnPage: number;
            readonly currentPage: number;
            readonly colorAlternation: boolean;
            readonly addRow: (up: boolean, index: number) => void;
            readonly deleteRow: (index: number) => void;
            readonly style?: Record<string, string> | undefined;
            readonly attrs?: object | undefined;
            readonly id?: string | undefined;
            readonly classes?: import("vue").StyleValue | undefined;
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Readonly<import("vue").ExtractPropTypes<{
            style: {
                type: import("vue").PropType<Record<string, string>>;
            };
            attrs: {
                type: import("vue").PropType<object>;
            };
            id: {
                type: import("vue").PropType<string>;
            };
            classes: {
                type: import("vue").PropType<import("vue").StyleValue>;
            };
            item: {
                type: import("vue").PropType<Record<string, unknown>>;
                required: true;
            };
            columns: {
                type: import("vue").PropType<GridColumns[]>;
                required: true;
            };
            showAddButtons: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            index: {
                type: import("vue").PropType<number>;
                required: true;
            };
            itemsOnPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            currentPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            colorAlternation: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            addRow: {
                type: import("vue").PropType<(up: boolean, index: number) => void>;
                required: true;
            };
            deleteRow: {
                type: import("vue").PropType<(index: number) => void>;
                required: true;
            };
        }>> & {
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        }, "showAddButtons" | "colorAlternation">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot<any> | undefined;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $emit: ((event: "mount") => void) & ((event: "unmount") => void) & ((event: "focusout") => void) & ((event: "focusin") => void) & ((event: "keydown", event: KeyboardEvent) => void) & ((event: "model-value-updated", value: Value) => void) & ((event: "update:modelValue", value: Value) => void) & ((event: "search", query: string) => void) & ((event: "beforeEdit", value: unknown) => void) & ((event: "afterEdit", value: unknown) => void) & ((event: "beforeChange", value: unknown) => void) & ((event: "afterChange", value: unknown) => void) & ((event: "queryUpdate", value: string) => void) & ((event: "rowClick", row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => void);
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            style: {
                type: import("vue").PropType<Record<string, string>>;
            };
            attrs: {
                type: import("vue").PropType<object>;
            };
            id: {
                type: import("vue").PropType<string>;
            };
            classes: {
                type: import("vue").PropType<import("vue").StyleValue>;
            };
            item: {
                type: import("vue").PropType<Record<string, unknown>>;
                required: true;
            };
            columns: {
                type: import("vue").PropType<GridColumns[]>;
                required: true;
            };
            showAddButtons: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            index: {
                type: import("vue").PropType<number>;
                required: true;
            };
            itemsOnPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            currentPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            colorAlternation: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            addRow: {
                type: import("vue").PropType<(up: boolean, index: number) => void>;
                required: true;
            };
            deleteRow: {
                type: import("vue").PropType<(index: number) => void>;
                required: true;
            };
        }>> & {
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        }, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
            mount: () => void;
            unmount: () => void;
            "update:modelValue": (value: Value) => void;
            "model-value-updated": (value: Value) => void;
            focusin: () => void;
            focusout: () => void;
            keydown: (event: KeyboardEvent) => void;
            search: (query: string) => void;
            queryUpdate: (value: string) => void;
            rowClick: (row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => void;
            afterChange: (value: unknown) => void;
            afterEdit: (value: unknown) => void;
            beforeEdit: (value: unknown) => void;
            beforeChange: (value: unknown) => void;
        }, string, {
            showAddButtons: boolean;
            colorAlternation: boolean;
        }, {}, string, {}> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<{
        style: {
            type: import("vue").PropType<Record<string, string>>;
        };
        attrs: {
            type: import("vue").PropType<object>;
        };
        id: {
            type: import("vue").PropType<string>;
        };
        classes: {
            type: import("vue").PropType<import("vue").StyleValue>;
        };
        item: {
            type: import("vue").PropType<Record<string, unknown>>;
            required: true;
        };
        columns: {
            type: import("vue").PropType<GridColumns[]>;
            required: true;
        };
        showAddButtons: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        index: {
            type: import("vue").PropType<number>;
            required: true;
        };
        itemsOnPage: {
            type: import("vue").PropType<number>;
            required: true;
        };
        currentPage: {
            type: import("vue").PropType<number>;
            required: true;
        };
        colorAlternation: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        addRow: {
            type: import("vue").PropType<(up: boolean, index: number) => void>;
            required: true;
        };
        deleteRow: {
            type: import("vue").PropType<(index: number) => void>;
            required: true;
        };
    }>> & {
        onFocusin?: (() => any) | undefined;
        onFocusout?: (() => any) | undefined;
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onMount?: (() => any) | undefined;
        onUnmount?: (() => any) | undefined;
        "onModel-value-updated"?: ((value: Value) => any) | undefined;
        "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
        onAfterChange?: ((value: unknown) => any) | undefined;
        onSearch?: ((query: string) => any) | undefined;
        onQueryUpdate?: ((value: string) => any) | undefined;
        onBeforeEdit?: ((value: unknown) => any) | undefined;
        onAfterEdit?: ((value: unknown) => any) | undefined;
        onBeforeChange?: ((value: unknown) => any) | undefined;
        onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
    } & import("vue").ShallowUnwrapRef<{}> & {} & import("vue").ComponentCustomProperties & {} & {
        $slots: Readonly<{
            default(props: {
                rowRef: import("vue").ComponentPublicInstance | null;
            }): any;
        }>;
    }) | null) => void;
    afterChange: (value: unknown) => void;
    afterEdit: (value: unknown) => void;
    beforeEdit: (value: unknown) => void;
    beforeChange: (value: unknown) => void;
    "update:page": (page: number) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    showAddButtons: boolean;
    itemsOnPage: number;
    hasFilter: boolean;
    colorAlternation: boolean;
    hideHeader: boolean;
    query: string;
    page: number;
}>>> & {
    onFocusin?: (() => any) | undefined;
    onFocusout?: (() => any) | undefined;
    onKeydown?: ((event: KeyboardEvent) => any) | undefined;
    onMount?: (() => any) | undefined;
    onUnmount?: (() => any) | undefined;
    "onModel-value-updated"?: ((value: Value) => any) | undefined;
    "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
    onAfterChange?: ((value: unknown) => any) | undefined;
    onSearch?: ((query: string) => any) | undefined;
    onQueryUpdate?: ((value: string) => any) | undefined;
    onBeforeEdit?: ((value: unknown) => any) | undefined;
    onAfterEdit?: ((value: unknown) => any) | undefined;
    onBeforeChange?: ((value: unknown) => any) | undefined;
    onRowClick?: ((row: Record<string, unknown>, rowRef: ({
        $: import("vue").ComponentInternalInstance;
        $data: {};
        $props: Partial<{
            showAddButtons: boolean;
            colorAlternation: boolean;
        }> & Omit<{
            readonly item: Record<string, unknown>;
            readonly columns: GridColumns[];
            readonly showAddButtons: boolean;
            readonly index: number;
            readonly itemsOnPage: number;
            readonly currentPage: number;
            readonly colorAlternation: boolean;
            readonly addRow: (up: boolean, index: number) => void;
            readonly deleteRow: (index: number) => void;
            readonly style?: Record<string, string> | undefined;
            readonly attrs?: object | undefined;
            readonly id?: string | undefined;
            readonly classes?: import("vue").StyleValue | undefined;
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & Readonly<import("vue").ExtractPropTypes<{
            style: {
                type: import("vue").PropType<Record<string, string>>;
            };
            attrs: {
                type: import("vue").PropType<object>;
            };
            id: {
                type: import("vue").PropType<string>;
            };
            classes: {
                type: import("vue").PropType<import("vue").StyleValue>;
            };
            item: {
                type: import("vue").PropType<Record<string, unknown>>;
                required: true;
            };
            columns: {
                type: import("vue").PropType<GridColumns[]>;
                required: true;
            };
            showAddButtons: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            index: {
                type: import("vue").PropType<number>;
                required: true;
            };
            itemsOnPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            currentPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            colorAlternation: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            addRow: {
                type: import("vue").PropType<(up: boolean, index: number) => void>;
                required: true;
            };
            deleteRow: {
                type: import("vue").PropType<(index: number) => void>;
                required: true;
            };
        }>> & {
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        }, "showAddButtons" | "colorAlternation">;
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: import("vue").Slot<any> | undefined;
        }>;
        $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $emit: ((event: "mount") => void) & ((event: "unmount") => void) & ((event: "focusout") => void) & ((event: "focusin") => void) & ((event: "keydown", event: KeyboardEvent) => void) & ((event: "model-value-updated", value: Value) => void) & ((event: "update:modelValue", value: Value) => void) & ((event: "search", query: string) => void) & ((event: "beforeEdit", value: unknown) => void) & ((event: "afterEdit", value: unknown) => void) & ((event: "beforeChange", value: unknown) => void) & ((event: "afterChange", value: unknown) => void) & ((event: "queryUpdate", value: string) => void) & ((event: "rowClick", row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => void);
        $el: any;
        $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            style: {
                type: import("vue").PropType<Record<string, string>>;
            };
            attrs: {
                type: import("vue").PropType<object>;
            };
            id: {
                type: import("vue").PropType<string>;
            };
            classes: {
                type: import("vue").PropType<import("vue").StyleValue>;
            };
            item: {
                type: import("vue").PropType<Record<string, unknown>>;
                required: true;
            };
            columns: {
                type: import("vue").PropType<GridColumns[]>;
                required: true;
            };
            showAddButtons: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            index: {
                type: import("vue").PropType<number>;
                required: true;
            };
            itemsOnPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            currentPage: {
                type: import("vue").PropType<number>;
                required: true;
            };
            colorAlternation: {
                type: import("vue").PropType<boolean>;
                default: boolean;
            };
            addRow: {
                type: import("vue").PropType<(up: boolean, index: number) => void>;
                required: true;
            };
            deleteRow: {
                type: import("vue").PropType<(index: number) => void>;
                required: true;
            };
        }>> & {
            onFocusin?: (() => any) | undefined;
            onFocusout?: (() => any) | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onMount?: (() => any) | undefined;
            onUnmount?: (() => any) | undefined;
            "onModel-value-updated"?: ((value: Value) => any) | undefined;
            "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
            onAfterChange?: ((value: unknown) => any) | undefined;
            onSearch?: ((query: string) => any) | undefined;
            onQueryUpdate?: ((value: string) => any) | undefined;
            onBeforeEdit?: ((value: unknown) => any) | undefined;
            onAfterEdit?: ((value: unknown) => any) | undefined;
            onBeforeChange?: ((value: unknown) => any) | undefined;
            onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
        }, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
            mount: () => void;
            unmount: () => void;
            "update:modelValue": (value: Value) => void;
            "model-value-updated": (value: Value) => void;
            focusin: () => void;
            focusout: () => void;
            keydown: (event: KeyboardEvent) => void;
            search: (query: string) => void;
            queryUpdate: (value: string) => void;
            rowClick: (row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => void;
            afterChange: (value: unknown) => void;
            afterEdit: (value: unknown) => void;
            beforeEdit: (value: unknown) => void;
            beforeChange: (value: unknown) => void;
        }, string, {
            showAddButtons: boolean;
            colorAlternation: boolean;
        }, {}, string, {}> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof import("vue").nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
    } & Readonly<import("vue").ExtractPropTypes<{
        style: {
            type: import("vue").PropType<Record<string, string>>;
        };
        attrs: {
            type: import("vue").PropType<object>;
        };
        id: {
            type: import("vue").PropType<string>;
        };
        classes: {
            type: import("vue").PropType<import("vue").StyleValue>;
        };
        item: {
            type: import("vue").PropType<Record<string, unknown>>;
            required: true;
        };
        columns: {
            type: import("vue").PropType<GridColumns[]>;
            required: true;
        };
        showAddButtons: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        index: {
            type: import("vue").PropType<number>;
            required: true;
        };
        itemsOnPage: {
            type: import("vue").PropType<number>;
            required: true;
        };
        currentPage: {
            type: import("vue").PropType<number>;
            required: true;
        };
        colorAlternation: {
            type: import("vue").PropType<boolean>;
            default: boolean;
        };
        addRow: {
            type: import("vue").PropType<(up: boolean, index: number) => void>;
            required: true;
        };
        deleteRow: {
            type: import("vue").PropType<(index: number) => void>;
            required: true;
        };
    }>> & {
        onFocusin?: (() => any) | undefined;
        onFocusout?: (() => any) | undefined;
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onMount?: (() => any) | undefined;
        onUnmount?: (() => any) | undefined;
        "onModel-value-updated"?: ((value: Value) => any) | undefined;
        "onUpdate:modelValue"?: ((value: Value) => any) | undefined;
        onAfterChange?: ((value: unknown) => any) | undefined;
        onSearch?: ((query: string) => any) | undefined;
        onQueryUpdate?: ((value: string) => any) | undefined;
        onBeforeEdit?: ((value: unknown) => any) | undefined;
        onAfterEdit?: ((value: unknown) => any) | undefined;
        onBeforeChange?: ((value: unknown) => any) | undefined;
        onRowClick?: ((row: Record<string, unknown>, rowRef: import("vue").ComponentPublicInstance | null) => any) | undefined;
    } & import("vue").ShallowUnwrapRef<{}> & {} & import("vue").ComponentCustomProperties & {} & {
        $slots: Readonly<{
            default(props: {
                rowRef: import("vue").ComponentPublicInstance | null;
            }): any;
        }>;
    }) | null) => any) | undefined;
    "onUpdate:page"?: ((page: number) => any) | undefined;
}, {
    showAddButtons: boolean;
    hasFilter: boolean;
    query: string;
    itemsOnPage: number;
    colorAlternation: boolean;
    hideHeader: boolean;
    page: number;
}, {}>, Partial<Record<any, (_: {
    item: any;
    row: any;
    setTrueFlag: any;
    rowRef: any;
}) => any>> & Partial<Record<string, (_: {
    value: any;
    update: any;
    isChangeAllowed: any;
    toggle: any;
    customChange: any;
    row: any;
    hideEdit: any;
    item: any;
    setTrueFlag: any;
    rowRef: any;
}) => any>>>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
